*******************************************************************************
*                                                                             *
*   FUNCTION : U_MEMOEDIT                                                     *
*                                                                             *
*       DATE : SEPTEMBER 21, 1989                                             *
*                                                                             *
* PROGRAMMER : MARK VIVANCO                                                   *
*                                                                             *
*    PURPOSE : TO LIMIT THE NUMBER OF LINES ALLOWED IN A MEMOEDIT FUNCTION    *
*              CALL                                                           *
*                                                                             *
* MISC NOTES : NOT FULLY FUNCTIONAL AND LIMIT.                                *
*                                                                             *
* PARAMETERS : TOP - TOP ROW FOR THE MEMOEDIT                                 *
*              LEFT - LEFT COLUMN FOR THE MEMOEDIT                            *
*              BOTTOM - BOTTOM ROW FOR THE MEMOEDIT                           *
*              RIGHT - RIGHT COLUMN FOR THE MEMOEDIT                          *
*              NUMLINES - THE NUMBER OF LINES ALLOWED FOR THE MEMOEDIT        *
*              LINELEN - THE MEMO LINE LENGTH                                 *
*              TABSIZE - THE TAB VALUE                                        *
*              INITMEMOLINE - INITIAL MEMO LINE WHERE CURSOR IS TO BE         *
*                        POSITIONED                                           *
*              INITMEMOCOL - INITIAL MEMO COLUMN WHERE CURSOR IS TO BE        *
*                        POSITIONED                                           *
*              INITROW - ROW RELATIVE TO WINDOW POSITION WHERE CURSOR WILL BE *
*                        POSITIONED                                           *
*              INITCOL - COLUMN RELATIVE TO WINDOW POSITION WHERE CURSOR WILL *
*                        BE POSITIONED                                        *
*                                                                             *
*  CALLED AS : U_MEMOEDIT(TOP, LEFT, BOTTOM, RIGHT, NUMLINES [,<LINELEN>]     *
*                         [,<TABSIZE>] [,<INITMEMOLINE>] [,<INITMEMOCOL>]     *
*                         [,<INITROW>] [,<INITCOL>]                           *
*                                                                             *
*******************************************************************************

FUNCTION U_MEMOEDIT
PARAMETERS TOP, LEFT, BOTTOM, RIGHT, NUMLINES, LINELEN, TABSIZE, ;
           INITMEMOLINE, INITMEMOCOL, INITROW, INITCOL

PRIVATE XXLINE     && HOLDS THE CURRENT LINE WE ARE ON
PRIVATE HOLDMEMO

IF ( PCOUNT() < 5 )
  ? "WRONG NUMBER OF PARAMETERS PASSED."
  RETURN ( "" )
ENDIF
&& SET UP DEFAULT PARAMETERS
LINELEN      = IIF(PCOUNT() = 5, "", LINELEN)
TABSIZE      = IIF(PCOUNT() <= 6, "", TABSIZE)
INITMEMOLINE = IIF(PCOUNT() <= 7, "", INITMEMOLINE)
INITMEMOCOL  = IIF(PCOUNT() <= 8, "", INITMEMOCOL)
INITROW      = IIF(PCOUNT() <= 9, "", INITROW)
INITCOL      = IIF(PCOUNT() <= 10, "", INITCOL)

PRIVATE SAVELINE
SAVELINE = SAVESCREEN(0, 0, 0, 79)  && SAVE THE TOP LINE SINCE THE UDF WRITES ON IT
SET KEY 13 TO PROCESSENTER          && START OUT INTERCEPTING THE ENTER KEY
READINSERT(.F.)
HOLDMEMO = MEMOEDIT("",TOP, LEFT, BOTTOM, RIGHT, .T., "USERFUNC", LINELEN, TABSIZE, ;
                  INITMEMOLINE, INITMEMOCOL, INITROW, INITCOL)
RESTSCREEN(0, 0, 0, 79, SAVELINE)   && PUT THE TOP LINE BACK
RETURN ( HOLDMEMO )


PROCEDURE PROCESSENTER
&& IF WE ARE HAVE NOT REACHED THE LAST LINE YET STOP THE INTERCEPTION OF THE
&&       ENTER KEY AND FORCE ANOTHER

IF ( XXLINE <> NUMLINES )         
  SET KEY 13 TO
  KEYBOARD CHR(13)
ENDIF
RETURN


FUNCTION USERFUNC
PARAMETERS STATUS, LINE, COL
PRIVATE LK
LK = LASTKEY()
XXLINE = LINE
@ 0, 1 SAY "LINE = " + ALLTRIM(STR(LINE)) + "   COL = " + ALLTRIM(STR(COL)) + "   "
DO CASE
   CASE ( STATUS = 0 )
     IF ( LK = 13 )
       && NOTE: THIS CAN ONLY BE REACHED WHEN PROCESS ENTER HAS TURNED OFF THE
       &&       ENTER KEY INTERCEPTION, AND PASSED AN ENTER KEY OF ITS OWN.
       &&       SO STOP ANY FURTHUR ENTER KEY HITS.
       SET KEY 13 TO PROCESSENTER
     ENDIF
     && DID WE REACH THE LAST LINE WE WANTED TO ALLOW?
     IF ( LINE = NUMLINES ) .AND. ( COL = (RIGHT - LEFT) )
       KEYBOARD CHR(19)      && IF SO FORCE A LEFT ARROW
       RETURN 33             && AND PROCESS THE LEFT ARROW
     ELSE
       RETURN 0              && ELSE CONTINUE PROCESSING KEYSTROKES
     ENDIF

   CASE ( STATUS = 1 )
     IF ( LK = 22 )          && DID WE HIT INSERT? IF SO IGNORE IT
       RETURN 32
     ENDIF

     IF ( LK = 27 )          && DID WE HIT ESCAPE WITHOUT ENTERING ANY INFO?
       RETURN 0              && IF SO IGNORE IT
     ENDIF

   CASE ( STATUS = 2 )
     IF ( LK = 22 )          && IGNORE THE INSERT KEY IF IT IS IT
       RETURN 32
     ENDIF

     IF ( LK = 27 )          && IF WE HIT ESCAPE WITH DATA IN THE FIELD SHOULD WE CONTINUE?
       PRIVATE TOPLINE, ABORT
       ABORT = "N"
       TOPLINE = SAVESCREEN(0, 0, 0, 79)
       @ 0, 64 SAY "ABORT EDIT? " GET ABORT PICTURE "Y"
       READ
       IF ( ABORT $ "Yy" )
         RETURN 0
       ELSE
         RESTSCREEN(0, 0, 0, 79, TOPLINE)
         RELEASE TOPLINE, ABORT
         RETURN 32
       ENDIF
     ENDIF
ENDCASE
RETURN 0
